diff --git a/java/yb-pgsql/src/test/java/org/yb/pgsql/TestPgRegressPgStat.java b/java/yb-pgsql/src/test/java/org/yb/pgsql/TestPgRegressPgStat.java
new file mode 100644
index 000000000000..6f4e4b0c898d
--- /dev/null
+++ b/java/yb-pgsql/src/test/java/org/yb/pgsql/TestPgRegressPgStat.java
@@ -0,0 +1,34 @@
+// Copyright (c) YugaByte, Inc.
+//
+// Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
+// in compliance with the License.  You may obtain a copy of the License at
+//
+// http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software distributed under the License
+// is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
+// or implied.  See the License for the specific language governing permissions and limitations
+// under the License.
+//
+
+package org.yb.pgsql;
+
+import org.junit.Test;
+import org.junit.runner.RunWith;
+import org.yb.util.YBTestRunnerNonTsanOnly;
+
+/**
+ * Runs the pg_regress test suite on YB code.
+ */
+@RunWith(value=YBTestRunnerNonTsanOnly.class)
+public class TestPgRegressPgStat extends BasePgSQLTest {
+  @Override
+  public int getTestMethodTimeoutSec() {
+    return 1800;
+  }
+
+  @Test
+  public void testPgStat() throws Exception {
+    runPgRegressTest("yb_pg_stat_schedule");
+  }
+}
diff --git a/src/postgres/src/backend/access/yb_access/yb_lsm.c b/src/postgres/src/backend/access/yb_access/yb_lsm.c
index 521151790f18..4a59bd3b5305 100644
--- a/src/postgres/src/backend/access/yb_access/yb_lsm.c
+++ b/src/postgres/src/backend/access/yb_access/yb_lsm.c
@@ -23,6 +23,7 @@
  */
 
 #include "postgres.h"
+#include "pgstat.h"
 
 #include "miscadmin.h"
 #include "access/nbtree.h"
@@ -390,7 +391,7 @@ ybcinbeginscan(Relation rel, int nkeys, int norderbys)
 	/* get the scan */
 	scan = RelationGetIndexScan(rel, nkeys, norderbys);
 	scan->opaque = NULL;
-
+	pgstat_count_index_scan(rel);
 	return scan;
 }
 
diff --git a/src/postgres/src/test/regress/expected/yb_pg_stat.out b/src/postgres/src/test/regress/expected/yb_pg_stat.out
new file mode 100644
index 000000000000..da022e87d7f5
--- /dev/null
+++ b/src/postgres/src/test/regress/expected/yb_pg_stat.out
@@ -0,0 +1,667 @@
+-- Test for PG_STAT
+-- test FOR LSM idx_scan in pg_stat_user_indexes
+create table maintable(c1 INT, c2 TEXT, PRIMARY KEY(c1));
+insert into maintable (c1, c2) values (4, 'bob');
+create index maintable_idx on maintable (c2) include (c1);
+/*+IndexOnlyScan(maintable_idx)*/
+select * from maintable where c2='bob';
+ c1 | c2
+----+-----
+  4 | bob
+(1 row)
+
+-- need to sleep for over half a second here since updates to pgstat is hardcoded to 500 milliseconds
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+ indexrelname  | idx_scan
+---------------+----------
+ maintable_idx |        1
+(1 row)
+
+/*+IndexScan(maintable)*/
+select * from maintable where c2='bob';
+ c1 | c2
+----+-----
+  4 | bob
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+ indexrelname  | idx_scan
+---------------+----------
+ maintable_idx |        2
+(1 row)
+
+-- negative case where we don't use index scan
+/*+SeqScan(maintable)*/
+select * from maintable;
+ c1 | c2
+----+-----
+  4 | bob
+(1 row)
+
+select * from maintable where c2='bob';
+ c1 | c2
+----+-----
+  4 | bob
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+ indexrelname  | idx_scan
+---------------+----------
+ maintable_idx |        3
+(1 row)
+
+-- test case for primary key scan
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_pkey';
+  indexrelname  | idx_scan
+----------------+----------
+ maintable_pkey |        0
+(1 row)
+
+/*+IndexScan(maintable)*/
+select * from maintable where c1=4;
+ c1 | c2
+----+-----
+  4 | bob
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+ indexrelname  | idx_scan
+---------------+----------
+ maintable_idx |        3
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_pkey';
+  indexrelname  | idx_scan
+----------------+----------
+ maintable_pkey |        1
+(1 row)
+
+-- test case for transaction abort
+begin;
+/*+IndexScan(maintable)*/
+select * from maintable where c2='bob';
+ c1 | c2
+----+-----
+  4 | bob
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+ indexrelname  | idx_scan
+---------------+----------
+ maintable_idx |        3
+(1 row)
+
+abort;
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+ indexrelname  | idx_scan
+---------------+----------
+ maintable_idx |        4
+(1 row)
+
+-- test for table view
+create view maintable_view as select * from maintable;
+select * from maintable_view where c2='bob';
+ c1 | c2
+----+-----
+  4 | bob
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+ indexrelname  | idx_scan
+---------------+----------
+ maintable_idx |        5
+(1 row)
+
+-- test for materialized table view
+create materialized view materialized_maintable_view as select * from maintable where c2='bob';
+select * from materialized_maintable_view where c2='bob';
+ c1 | c2
+----+-----
+  4 | bob
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+ indexrelname  | idx_scan
+---------------+----------
+ maintable_idx |        6
+(1 row)
+
+-- test for refreshing materialized table view
+insert into maintable (c1, c2) values (6, 'sol');
+/*+IndexScan(maintable) IndexScan(materialized_maintable_view)*/
+refresh materialized view materialized_maintable_view;
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+ indexrelname  | idx_scan
+---------------+----------
+ maintable_idx |        7
+(1 row)
+
+-- test for refreshing materialized table view with index
+create index materialized_view_idx on materialized_maintable_view (c2) include (c1);
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='materialized_view_idx';
+     indexrelname      | idx_scan
+-----------------------+----------
+ materialized_view_idx |        0
+(1 row)
+
+select * from materialized_maintable_view where c2='bob';
+ c1 | c2
+----+-----
+  4 | bob
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='materialized_view_idx';
+     indexrelname      | idx_scan
+-----------------------+----------
+ materialized_view_idx |        1
+(1 row)
+
+refresh materialized view materialized_maintable_view;
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+-- currently, after a refresh materialized view is called, idx_scan is reset
+-- this is not consistent with upstream PG and needs to be fixed
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='materialized_view_idx';
+     indexrelname      | idx_scan
+-----------------------+----------
+ materialized_view_idx |        0
+(1 row)
+
+-- test for joined table
+create table table2 (c1 INT PRIMARY KEY, c2 TEXT);
+insert into table2 (c1, c2) values (8, 'bob');
+create index table2_index on table2 (c2) include (c1);
+/*+IndexScan(table2) */
+explain (costs off) select maintable.c1, table2.c1, table2.c2 from maintable, table2 where table2.c2=maintable.c2;
+                  QUERY PLAN
+-----------------------------------------------
+ Nested Loop
+   ->  Seq Scan on maintable
+   ->  Index Scan using table2_index on table2
+         Index Cond: (c2 = maintable.c2)
+(4 rows)
+
+/*+IndexScan(table2) */
+select maintable.c1, table2.c1, table2.c2 from maintable, table2 where table2.c2=maintable.c2;
+ c1 | c1 | c2
+----+----+-----
+  4 |  8 | bob
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname in ('maintable_idx', 'table2_index') order by (indexrelname);
+ indexrelname  | idx_scan
+---------------+----------
+ maintable_idx |        8
+ table2_index  |        1
+(2 rows)
+
+/*+IndexScan(maintable)*/
+explain (costs off) select table2.c1, table2.c2, maintable.c1 from table2, maintable where table2.c2=maintable.c2;
+                    QUERY PLAN
+---------------------------------------------------
+ Nested Loop
+   ->  Seq Scan on table2
+   ->  Index Scan using maintable_idx on maintable
+         Index Cond: (c2 = table2.c2)
+(4 rows)
+
+/*+IndexScan(maintable)*/
+select table2.c1, table2.c2, maintable.c1 from table2, maintable where table2.c2=maintable.c2;
+ c1 | c2  | c1
+----+-----+----
+  8 | bob |  4
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname in ('maintable_idx', 'table2_index') order by (indexrelname);
+ indexrelname  | idx_scan
+---------------+----------
+ maintable_idx |        9
+ table2_index  |        1
+(2 rows)
+
+-- test for multitablet table
+create table multitablet_table (c1 INT PRIMARY KEY, c2 TEXT) split into 3 tablets;
+insert into multitablet_table (c1, c2) values (9, 'caledonia');
+create index multitablet_table_index on multitablet_table (c2) include (c1);
+select * from multitablet_table where c2='caledonia';
+ c1 |    c2
+----+-----------
+  9 | caledonia
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='multitablet_table_index';
+      indexrelname       | idx_scan
+-------------------------+----------
+ multitablet_table_index |        1
+(1 row)
+
+-- test for alter table primary key
+create table basic_table (c1 INT, c2 TEXT);
+insert into basic_table (c1, c2) values (6, '9');
+create index basic_table_idx1 on basic_table (c1) include (c2);
+create index basic_table_idx2 on basic_table (c2) include (c1);
+select * from basic_table where c1=6;
+ c1 | c2
+----+----
+  6 | 9
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'basic_table_idx.' order by (indexrelname);
+   indexrelname   | idx_scan
+------------------+----------
+ basic_table_idx1 |        1
+ basic_table_idx2 |        0
+(2 rows)
+
+select * from basic_table where c2='9';
+ c1 | c2
+----+----
+  6 | 9
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'basic_table_idx.' order by (indexrelname);
+   indexrelname   | idx_scan
+------------------+----------
+ basic_table_idx1 |        1
+ basic_table_idx2 |        1
+(2 rows)
+
+alter table basic_table add primary key (c1);
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+-- currently, alter table primary key resets the idx_scan count to zero
+-- this does not happen in upstream Postgres, will need to fix
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'basic_table_idx.' or indexrelname='basic_table_pkey' order by (indexrelname);
+   indexrelname   | idx_scan
+------------------+----------
+ basic_table_idx1 |        0
+ basic_table_idx2 |        0
+ basic_table_pkey |        0
+(3 rows)
+
+select * from basic_table where c1=6;
+ c1 | c2
+----+----
+  6 | 9
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'basic_table_idx.' or indexrelname='basic_table_pkey' order by (indexrelname);
+   indexrelname   | idx_scan
+------------------+----------
+ basic_table_idx1 |        0
+ basic_table_idx2 |        0
+ basic_table_pkey |        1
+(3 rows)
+
+select * from basic_table where c2='9';
+ c1 | c2
+----+----
+  6 | 9
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'basic_table_idx.' or indexrelname='basic_table_pkey' order by (indexrelname);
+   indexrelname   | idx_scan
+------------------+----------
+ basic_table_idx1 |        0
+ basic_table_idx2 |        1
+ basic_table_pkey |        1
+(3 rows)
+
+-- test for temporary table index
+create temporary table temp_table (c1 INT PRIMARY KEY, c2 TEXT);
+insert into temp_table (c1, c2) values (9, 'penguin');
+create index temp_index on temp_table (c2) include (c1);
+/*+IndexScan(temp_table)*/
+explain (costs off) select * from temp_table where c2='penguin';
+                QUERY PLAN
+-------------------------------------------
+ Index Scan using temp_index on temp_table
+   Index Cond: (c2 = 'penguin'::text)
+(2 rows)
+
+/*+IndexScan(temp_table)*/
+select * from temp_table where c2='penguin';
+ c1 |   c2
+----+---------
+  9 | penguin
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='temp_index';
+ indexrelname | idx_scan
+--------------+----------
+ temp_index   |        1
+(1 row)
+
+-- test for partitioned tables
+create table partitioned_table (k INT, v TEXT) partition by range (k);
+create table p1 partition of partitioned_table
+  for values from (1) to (3);
+create table p2 partition of partitioned_table
+  for values from (3) to (5);
+create table p3 partition of partitioned_table
+  for values from (5) to (7);
+insert into partitioned_table (k, v) values (2, '2');
+insert into partitioned_table (k, v) values (4, '2');
+insert into partitioned_table (k, v) values (6, '2');
+create index partitioned_idx on partitioned_table (v) include (k);
+select * from partitioned_table where v='2' order by (k);
+ k | v
+---+---
+ 2 | 2
+ 4 | 2
+ 6 | 2
+(3 rows)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'p._v_k_idx' order by (indexrelname);
+ indexrelname | idx_scan
+--------------+----------
+ p1_v_k_idx   |        1
+ p2_v_k_idx   |        1
+ p3_v_k_idx   |        1
+(3 rows)
+
+drop index if exists partitioned_idx;
+create index p1idx on p1 (v) include (k);
+create index p2idx on p2 (v) include (k);
+create index p3idx on p3 (v) include (k);
+select * from partitioned_table where v='2' order by (k);
+ k | v
+---+---
+ 2 | 2
+ 4 | 2
+ 6 | 2
+(3 rows)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'p.idx' order by (indexrelname);
+ indexrelname | idx_scan
+--------------+----------
+ p1idx        |        1
+ p2idx        |        1
+ p3idx        |        1
+(3 rows)
+
+
+-- test for GIN idx_scan increment
+create table pendtest (ts tsvector);
+create index pendtest_idx on pendtest using gin(ts);
+insert into pendtest values (to_tsvector('Lore ipsum'));
+/*+IndexScan(pendtest)*/
+select * from pendtest where 'ipsu:*'::tsquery @@ ts;
+         ts
+--------------------
+ 'ipsum':2 'lore':1
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='pendtest_idx';
+ indexrelname | idx_scan
+--------------+----------
+ pendtest_idx |        1
+(1 row)
+
+-- negative case where we don't use index scan
+/*+SeqScan(pendtest)*/
+select * from pendtest;
+         ts
+--------------------
+ 'ipsum':2 'lore':1
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='pendtest_idx';
+ indexrelname | idx_scan
+--------------+----------
+ pendtest_idx |        1
+(1 row)
+
+-- temp index for GIN table
+drop table if exists pendtest cascade;
+create temporary table pendtest (ts tsvector);
+create index pendtest_idx on pendtest using gin(ts);
+insert into pendtest values (to_tsvector('Lore ipsum'));
+-- this should be an index scan but is for some reason still a sequential scan
+-- we will need to fix this during planning phase, ignores pg_hint_plan
+/*+IndexScan(pendtest)*/
+explain (costs off) select * from pendtest where ts @@ to_tsquery('ipsu:*');
+                       QUERY PLAN
+--------------------------------------------------------
+ Bitmap Heap Scan on pendtest
+   Recheck Cond: (ts @@ to_tsquery('ipsu:*'::text))
+   ->  Bitmap Index Scan on pendtest_idx
+         Index Cond: (ts @@ to_tsquery('ipsu:*'::text))
+(4 rows)
+
+/*+IndexScan(pendtest)*/
+select * from pendtest where ts @@ to_tsquery('ipsu:*');
+         ts
+--------------------
+ 'ipsum':2 'lore':1
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='pendtest_idx';
+ indexrelname | idx_scan
+--------------+----------
+ pendtest_idx |        1
+(1 row)
+
+-- negative case where we don't use index scan
+/*+SeqScan(pendtest)*/
+explain (costs off) select * from pendtest;
+      QUERY PLAN
+----------------------
+ Seq Scan on pendtest
+(1 row)
+
+/*+SeqScan(pendtest)*/
+select * from pendtest;
+         ts
+--------------------
+ 'ipsum':2 'lore':1
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='pendtest_idx';
+ indexrelname | idx_scan
+--------------+----------
+ pendtest_idx |        1
+(1 row)
+
+-- test for colocated table
+create database colocated_db with colocated = true;
+\c colocated_db;
+create table mycolocatedtable (c1 INT PRIMARY KEY, c2 TEXT, c3 INT);
+insert into mycolocatedtable (c1, c2, c3) values (6, '9', 8);
+create index mycolocatedtable_index1 on mycolocatedtable (c2);
+create index mycolocatedtable_index2 on mycolocatedtable (c3);
+select * from mycolocatedtable where c2='9';
+ c1 | c2 | c3
+----+----+----
+  6 | 9  |  8
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'mycolocatedtable_index.' order by (indexrelname);
+      indexrelname       | idx_scan
+-------------------------+----------
+ mycolocatedtable_index1 |        1
+ mycolocatedtable_index2 |        0
+(2 rows)
+
+select * from mycolocatedtable where c3=8;
+ c1 | c2 | c3
+----+----+----
+  6 | 9  |  8
+(1 row)
+
+select pg_sleep(1);
+ pg_sleep
+----------
+
+(1 row)
+
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'mycolocatedtable_index.' order by (indexrelname);
+      indexrelname       | idx_scan
+-------------------------+----------
+ mycolocatedtable_index1 |        1
+ mycolocatedtable_index2 |        1
+(2 rows)
diff --git a/src/postgres/src/test/regress/sql/yb_pg_stat.sql b/src/postgres/src/test/regress/sql/yb_pg_stat.sql
new file mode 100644
index 000000000000..fdbc239e04a9
--- /dev/null
+++ b/src/postgres/src/test/regress/sql/yb_pg_stat.sql
@@ -0,0 +1,213 @@
+-- Test for PG_STAT
+-- test FOR LSM idx_scan in pg_stat_user_indexes
+create table maintable(c1 INT, c2 TEXT, PRIMARY KEY(c1));
+insert into maintable (c1, c2) values (4, 'bob');
+create index maintable_idx on maintable (c2) include (c1);
+/*+IndexOnlyScan(maintable_idx)*/
+select * from maintable where c2='bob';
+-- need to sleep for over half a second here since updates to pgstat is hardcoded to 500 milliseconds
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+
+/*+IndexScan(maintable)*/
+select * from maintable where c2='bob';
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+
+-- negative case where we don't use index scan
+/*+SeqScan(maintable)*/
+select * from maintable;
+select * from maintable where c2='bob';
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+
+-- test case for primary key scan
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_pkey';
+/*+IndexScan(maintable)*/
+select * from maintable where c1=4;
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_pkey';
+
+-- test case for transaction abort
+begin;
+/*+IndexScan(maintable)*/
+select * from maintable where c2='bob';
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+abort;
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+
+-- test for table view
+create view maintable_view as select * from maintable;
+select * from maintable_view where c2='bob';
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+
+-- test for materialized table view
+create materialized view materialized_maintable_view as select * from maintable where c2='bob';
+select * from materialized_maintable_view where c2='bob';
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+
+-- test for refreshing materialized table view
+insert into maintable (c1, c2) values (6, 'sol'); 
+/*+IndexScan(maintable) IndexScan(materialized_maintable_view)*/
+refresh materialized view materialized_maintable_view;
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='maintable_idx';
+
+-- test for refreshing materialized table view with index
+create index materialized_view_idx on materialized_maintable_view (c2) include (c1);
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='materialized_view_idx';
+select * from materialized_maintable_view where c2='bob';
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='materialized_view_idx';
+refresh materialized view materialized_maintable_view;
+select pg_sleep(1);
+-- currently, after a refresh materialized view is called, idx_scan is reset 
+-- this is not consistent with upstream PG and needs to be fixed
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='materialized_view_idx';
+
+-- test for joined table
+create table table2 (c1 INT PRIMARY KEY, c2 TEXT);
+insert into table2 (c1, c2) values (8, 'bob');
+create index table2_index on table2 (c2) include (c1);
+/*+IndexScan(table2) */
+explain (costs off) select maintable.c1, table2.c1, table2.c2 from maintable, table2 where table2.c2=maintable.c2;
+/*+IndexScan(table2) */
+select maintable.c1, table2.c1, table2.c2 from maintable, table2 where table2.c2=maintable.c2;
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname in ('maintable_idx', 'table2_index') order by (indexrelname);
+
+/*+IndexScan(maintable)*/
+explain (costs off) select table2.c1, table2.c2, maintable.c1 from table2, maintable where table2.c2=maintable.c2;
+/*+IndexScan(maintable)*/
+select table2.c1, table2.c2, maintable.c1 from table2, maintable where table2.c2=maintable.c2;
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname in ('maintable_idx', 'table2_index') order by (indexrelname);
+
+-- test for multitablet table
+create table multitablet_table (c1 INT PRIMARY KEY, c2 TEXT) split into 3 tablets;
+insert into multitablet_table (c1, c2) values (9, 'caledonia');
+create index multitablet_table_index on multitablet_table (c2) include (c1);
+select * from multitablet_table where c2='caledonia';
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='multitablet_table_index';
+
+-- test for alter table primary key
+create table basic_table (c1 INT, c2 TEXT);
+insert into basic_table (c1, c2) values (6, '9');
+create index basic_table_idx1 on basic_table (c1) include (c2);
+create index basic_table_idx2 on basic_table (c2) include (c1);
+select * from basic_table where c1=6;
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'basic_table_idx.' order by (indexrelname);
+select * from basic_table where c2='9';
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'basic_table_idx.' order by (indexrelname);
+
+alter table basic_table add primary key (c1);
+
+select pg_sleep(1);
+-- currently, alter table primary key resets the idx_scan count to zero
+-- this does not happen in upstream Postgres, will need to fix
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'basic_table_idx.' or indexrelname='basic_table_pkey' order by (indexrelname);
+select * from basic_table where c1=6;
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'basic_table_idx.' or indexrelname='basic_table_pkey' order by (indexrelname);
+select * from basic_table where c2='9';
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'basic_table_idx.' or indexrelname='basic_table_pkey' order by (indexrelname);
+
+-- test for temporary table index
+create temporary table temp_table (c1 INT PRIMARY KEY, c2 TEXT);
+insert into temp_table (c1, c2) values (9, 'penguin');
+create index temp_index on temp_table (c2) include (c1);
+/*+IndexScan(temp_table)*/
+explain (costs off) select * from temp_table where c2='penguin';
+/*+IndexScan(temp_table)*/
+select * from temp_table where c2='penguin';
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='temp_index';
+
+-- test for partitioned tables
+create table partitioned_table (k INT, v TEXT) partition by range (k);
+create table p1 partition of partitioned_table
+  for values from (1) to (3);
+create table p2 partition of partitioned_table
+  for values from (3) to (5);
+create table p3 partition of partitioned_table
+  for values from (5) to (7);
+insert into partitioned_table (k, v) values (2, '2');
+insert into partitioned_table (k, v) values (4, '2');
+insert into partitioned_table (k, v) values (6, '2');
+create index partitioned_idx on partitioned_table (v) include (k);
+select * from partitioned_table where v='2' order by (k);
+
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'p._v_k_idx' order by (indexrelname);
+
+drop index if exists partitioned_idx;
+create index p1idx on p1 (v) include (k);
+create index p2idx on p2 (v) include (k);
+create index p3idx on p3 (v) include (k);
+select * from partitioned_table where v='2' order by (k);
+
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'p.idx' order by (indexrelname);
+  
+-- test for GIN idx_scan increment
+create table pendtest (ts tsvector);
+create index pendtest_idx on pendtest using gin(ts);
+insert into pendtest values (to_tsvector('Lore ipsum'));
+/*+IndexScan(pendtest)*/
+select * from pendtest where 'ipsu:*'::tsquery @@ ts;
+
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='pendtest_idx';
+
+-- negative case where we don't use index scan
+/*+SeqScan(pendtest)*/
+select * from pendtest;
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='pendtest_idx';
+
+-- temp index for GIN table
+drop table if exists pendtest cascade;
+create temporary table pendtest (ts tsvector);
+create index pendtest_idx on pendtest using gin(ts);
+insert into pendtest values (to_tsvector('Lore ipsum'));
+-- this should be an index scan but is for some reason still a sequential scan
+-- we will need to fix this during planning phase, ignores pg_hint_plan
+/*+IndexScan(pendtest)*/
+explain (costs off) select * from pendtest where ts @@ to_tsquery('ipsu:*');
+/*+IndexScan(pendtest)*/
+select * from pendtest where ts @@ to_tsquery('ipsu:*');
+
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='pendtest_idx';
+
+-- negative case where we don't use index scan
+/*+SeqScan(pendtest)*/
+explain (costs off) select * from pendtest;
+/*+SeqScan(pendtest)*/
+select * from pendtest;
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname='pendtest_idx';
+
+-- test for colocated table
+create database colocated_db with colocated = true;
+\c colocated_db;
+create table mycolocatedtable (c1 INT PRIMARY KEY, c2 TEXT, c3 INT);
+insert into mycolocatedtable (c1, c2, c3) values (6, '9', 8);
+create index mycolocatedtable_index1 on mycolocatedtable (c2);
+create index mycolocatedtable_index2 on mycolocatedtable (c3);
+select * from mycolocatedtable where c2='9';
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'mycolocatedtable_index.' order by (indexrelname);
+select * from mycolocatedtable where c3=8;
+select pg_sleep(1);
+select indexrelname,idx_scan from pg_stat_user_indexes where indexrelname ~ 'mycolocatedtable_index.' order by (indexrelname);
diff --git a/src/postgres/src/test/regress/yb_pg_stat_schedule b/src/postgres/src/test/regress/yb_pg_stat_schedule
new file mode 100644
index 000000000000..66bc44a50fef
--- /dev/null
+++ b/src/postgres/src/test/regress/yb_pg_stat_schedule
@@ -0,0 +1,6 @@
+# src/test/regress/yb_pg_stat_schedule
+#
+####################################################################################################
+# Testsuite for tests covering pg_stat collection behavior.
+####################################################################################################
+test: yb_pg_stat
